#include <bits/stdc++.h>
using namespace std;

const vector<int> DR = {-1, 1, 0, 0};
const vector<int> DC = {0, 0, -1, 1};

struct veza {
    int r, c, t, dodola;
    veza(int r, int c, int t) : r(r), c(c), t(t), dodola(0) {}
};

int main() {
    // nacitanie vstupu
    int D, N;
    cin >> D >> N;
    vector<veza> V;
    for (int n=0; n<N; ++n) {
        int r, c;
        string t;
        cin >> r >> c >> t;
        V.emplace_back(r,c,t == "B" ? 1 : 2);
    }
    
    // kompresia suradnic
    unordered_map<int,int> redukuj_riadok, redukuj_stlpec;
    vector<int> riadkove_bloky, stlpcove_bloky;

    {
        vector<int> suradnice; 
        for (auto v : V) suradnice.push_back(v.r);
        set<int> rozne_suradnice( suradnice.begin(), suradnice.end() );
        suradnice = vector<int>( rozne_suradnice.begin(), rozne_suradnice.end() );
        for (int i=0; i<int(suradnice.size()); ++i) redukuj_riadok[suradnice[i]] = 2*i+1;
        int last = -1;
        for (int s : suradnice) {
            riadkove_bloky.push_back(s - last - 1);
            riadkove_bloky.push_back(1);
            last = s;
        }
        riadkove_bloky.push_back(D - last - 1);
    }

    {
        vector<int> suradnice; 
        for (auto v : V) suradnice.push_back(v.c);
        set<int> rozne_suradnice( suradnice.begin(), suradnice.end() );
        suradnice = vector<int>( rozne_suradnice.begin(), rozne_suradnice.end() );
        for (int i=0; i<int(suradnice.size()); ++i) redukuj_stlpec[suradnice[i]] = 2*i+1;
        int last = -1;
        for (int s : suradnice) {
            stlpcove_bloky.push_back(s - last - 1);
            stlpcove_bloky.push_back(1);
            last = s;
        }
        stlpcove_bloky.push_back(D - last - 1);
    }

    // vykreslenie vsetkeho do mriezky

    int R = 2*redukuj_riadok.size() + 1, C = 2*redukuj_stlpec.size() + 1;
    vector< vector<int> > sachovnica(R, vector<int>(C,0));
    vector< vector<int> > biele(R, vector<int>(C,0));
    vector< vector<int> > cierne(R, vector<int>(C,0));

    for (auto v : V) sachovnica[ redukuj_riadok[v.r] ][ redukuj_stlpec[v.c] ] = v.t;

    for (int r=0; r<R; ++r) for (int c=0; c<C; ++c) if (sachovnica[r][c] > 0) {
        for (int d=0; d<4; ++d) {
            int cr = r, cc = c;
            while (true) {
                if (sachovnica[r][c] == 1) ++biele[cr][cc]; else ++cierne[cr][cc];
                cr += DR[d];
                cc += DC[d];
                if (cr < 0 || cr >= R || cc < 0 || cc >= C) break;
                if (sachovnica[cr][cc] != 0) break;
            }
        }
    }

    vector< vector<long long> > odpoved(5, vector<long long>(5,0));
    for (int r=0; r<R; ++r) for (int c=0; c<C; ++c) if (sachovnica[r][c] == 0) odpoved[ biele[r][c] ][ cierne[r][c] ] += 1LL * riadkove_bloky[r] * stlpcove_bloky[c];
    for (int b=0; b<5; ++b) for (int c=0; c<5; ++c) if (odpoved[b][c] > 0) cout << b << " " << c << " " << odpoved[b][c] << endl;
}
